/*
 * $RCSfile: NetworkInfo.cc,v $
 * $Revision: 1.1 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: mlyko $          $Locker:  $
 * $Date: 2005-08-23 09:09:14 $
 * $Log: not supported by cvs2svn $
 */

#include <stdio.h>
#include <sys/types.h>
#include <winsock2.h>
#include <ws2tcpip.h>

#include "NetworkInfo.h"

NetworkInfo::NetworkInfo()
{
}

NetworkInfo::~NetworkInfo()
{
}

void NetworkInfo::ReadNetworkInfo(char* ip_address, char* net_mask, char* broadcast)
{
    printf("ReadNetworkInfo() started... \n");
    
    int wsError;
    SOCKET s;
    DWORD bytesReturned;
    char* pAddrString;
    SOCKADDR_IN* pAddrInet;
    u_long SetFlags;
    INTERFACE_INFO localAddr[10];  // Assume there will be no more than 10 IP interfaces 
    int numLocalAddr; 
    
    WSADATA wsaData;
    if (WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) {
       perror("WSAStartup failed\n");
       return;
    }
    
    if((s = WSASocket(AF_INET, SOCK_DGRAM, IPPROTO_UDP, NULL, 0, 0)) == INVALID_SOCKET)
    {
        perror( "Socket creation failed\n");
        WSACleanup();
        return;
    }
    
    wsError = WSAIoctl(s, SIO_GET_INTERFACE_LIST, NULL, 0, &localAddr,
                      sizeof(localAddr), &bytesReturned, NULL, NULL);
    
    if (wsError == SOCKET_ERROR)
    {
        fprintf(stderr, "WSAIoctl fails with error %d\n", GetLastError());
        closesocket(s);
        WSACleanup();
        return;
    }

    closesocket(s);
    numLocalAddr = (bytesReturned/sizeof(INTERFACE_INFO));
    for (int i=0; i<numLocalAddr; i++) 
    {
        SetFlags = localAddr[i].iiFlags;
        if (!( SetFlags & IFF_UP)){
            continue;// interface is down
        }
        if (SetFlags & IFF_LOOPBACK){
            continue;// loopback not interesting
        }
        pAddrInet = (SOCKADDR_IN*)&localAddr[i].iiAddress;
        
        pAddrString = inet_ntoa(pAddrInet->sin_addr);
        strcpy(ip_address, pAddrString);
        pAddrInet = (SOCKADDR_IN*)&localAddr[i].iiNetmask;
        pAddrString = inet_ntoa(pAddrInet->sin_addr);
        strcpy(net_mask, pAddrString);

        pAddrInet = (SOCKADDR_IN*)&localAddr[i].iiBroadcastAddress;
        pAddrString = inet_ntoa(pAddrInet->sin_addr);
        strcpy(broadcast, pAddrString);
        break;

    }
    WSACleanup();
}
